Cgl 0.60.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Groups Pages
Public Member Functions | Protected Attributes | Private Member Functions | List of all members
CglTreeProbingInfo Class Reference

`#include <CglTreeInfo.hpp>`

Inheritance diagram for CglTreeProbingInfo:
[legend]
Collaboration diagram for CglTreeProbingInfo:
[legend]

## Public Member Functions
| CglTreeProbingInfo ()
| Default constructor. More...
| CglTreeProbingInfo (const OsiSolverInterface *model)
| Constructor from model. More...
| CglTreeProbingInfo (const CglTreeProbingInfo &)
| Copy constructor. More...
virtual CglTreeInfo * | clone () const
| Clone. More...
CglTreeProbingInfo & | operator= (const CglTreeProbingInfo &rhs)
| Assignment operator. More...
virtual | ~CglTreeProbingInfo ()
| Destructor. More...
OsiSolverInterface * | analyze (const OsiSolverInterface &si, int createSolver=0, int numberExtraCliques=0, const CoinBigIndex *starts=NULL, const CliqueEntry *entries=NULL, const char *type=NULL)
virtual bool | fixes (int variable, int toValue, int fixedVariable, bool fixedToLower)
| Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not. More...
virtual int | initializeFixing (const OsiSolverInterface *model)
| Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used. More...
int | fixColumns (OsiSolverInterface &si) const
| Fix entries in a solver using implications. More...
int | fixColumns (int iColumn, int value, OsiSolverInterface &si) const
| Fix entries in a solver using implications for one variable. More...
int | packDown ()
| Packs down entries. More...
void | generateCuts (const OsiSolverInterface &si, OsiCuts &cs, const CglTreeInfo info) const
| Generate cuts from implications. More...
CliqueEntry * | fixEntries ()
| Entries for fixing variables. More...
int * | toZero ()
| Starts of integer variable going to zero. More...
int * | toOne ()
| Starts of integer variable going to one. More...
int * | integerVariable () const
| List of 0-1 integer variables. More...
int * | backward () const
| Backward look up. More...
int | numberVariables () const
| Number of variables. More...
int | numberIntegers () const
| Number of 0-1 variables. More...
Public Member Functions inherited from CglTreeInfo
| CglTreeInfo ()
| Default constructor. More...
| CglTreeInfo (const CglTreeInfo &)
| Copy constructor. More...
CglTreeInfo & | operator= (const CglTreeInfo &rhs)
| Assignment operator. More...
virtual | ~CglTreeInfo ()
| Destructor. More...

## Protected Attributes
CliqueEntry * | fixEntry_
| Entries for fixing variables. More...
int * | toZero_
| Starts of integer variable going to zero. More...
int * | toOne_
| Starts of integer variable going to one. More...
int * | integerVariable_
| List of 0-1 integer variables. More...
int * | backward_
| Backward look up. More...
int * | fixingEntry_
| Entries for fixing variable when collecting. More...
int | numberVariables_
| Number of variables. More...
int | numberIntegers_
| Number of 0-1 variables. More...
int | maximumEntries_
| Maximum number in fixEntry_. More...
int | numberEntries_
| Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style. More...

## Private Member Functions
void | convert ()
| Converts to ordered. More...

## Additional Inherited Members
Public Attributes inherited from CglTreeInfo
int | level
| The level of the search tree node. More...
int | pass
| How many times the cut generator was already invoked in this search tree node. More...
int | formulation_rows
| The number of rows in the original formulation. More...
int | options
| Options 1 - treat costed integers as important 2 - switch off some stuff as variables semi-integer 4 - set global cut flag if at root node 8 - set global cut flag if at root node and first pass 16 - set global cut flag and make cuts globally valid 32 - last round of cuts did nothing - maybe be more aggressive 64 - in preprocessing stage 128 - looks like solution 256 - want alternate cuts 512 - in sub tree (i.e. More...
bool | inTree
| Set true if in tree (to avoid ambiguity at first branch) More...
int | hasParent
| nonzero if called from child of main model 1 if heuristic run 2 if doing full search More...
OsiSolverInterface * | parentSolver
| parent solver More...
int * | originalColumns
| Original columns (if preprocessed) More...
OsiRowCut ** | strengthenRow
| Replacement array. More...
CoinThreadRandom * | randomNumberGenerator
| Optional pointer to thread specific random number generator. More...

## Detailed Description

Definition at line 92 of file CglTreeInfo.hpp.

## Constructor & Destructor Documentation

CglTreeProbingInfo::CglTreeProbingInfo | ( |  | ) |

Default constructor.

CglTreeProbingInfo::CglTreeProbingInfo | ( | const OsiSolverInterface * | model | ) |

Constructor from model.

CglTreeProbingInfo::CglTreeProbingInfo | ( | const CglTreeProbingInfo & |  | ) |

Copy constructor.

virtual CglTreeProbingInfo::~CglTreeProbingInfo | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

virtual CglTreeInfo* CglTreeProbingInfo::clone | ( |  | ) | const
| virtual

Clone.

Reimplemented from CglTreeInfo.

CglTreeProbingInfo& CglTreeProbingInfo::operator= | ( | const CglTreeProbingInfo & | rhs | ) |

Assignment operator.

OsiSolverInterface* CglTreeProbingInfo::analyze | ( | const OsiSolverInterface & | si,
|  | int | createSolver = `0`,
|  | int | numberExtraCliques = `0`,
|  | const CoinBigIndex * | starts = `NULL`,
|  | const CliqueEntry * | entries = `NULL`,
|  | const char * | type = `NULL`
| ) |  |

virtual bool CglTreeProbingInfo::fixes | ( | int | variable,
|  | int | toValue,
|  | int | fixedVariable,
|  | bool | fixedToLower
| ) |  |
| virtual

Take action if cut generator can fix a variable (toValue -1 for down, +1 for up) Returns true if still room, false if not.

Reimplemented from CglTreeInfo.

virtual int CglTreeProbingInfo::initializeFixing | ( | const OsiSolverInterface * | model | ) |
| virtual

Initalizes fixing arrays etc - returns >0 if we want to save info 0 if we don't and -1 if is to be used.

Reimplemented from CglTreeInfo.

int CglTreeProbingInfo::fixColumns | ( | OsiSolverInterface & | si | ) | const

Fix entries in a solver using implications.

int CglTreeProbingInfo::fixColumns | ( | int | iColumn,
|  | int | value,
|  | OsiSolverInterface & | si
| ) |  | const

Fix entries in a solver using implications for one variable.

int CglTreeProbingInfo::packDown | ( |  | ) |

Packs down entries.

void CglTreeProbingInfo::generateCuts | ( | const OsiSolverInterface & | si,
|  | OsiCuts & | cs,
|  | const CglTreeInfo | info
| ) |  | const

Generate cuts from implications.

CliqueEntry* CglTreeProbingInfo::fixEntries | ( |  | ) |
| inline

Entries for fixing variables.

Definition at line 132 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toZero | ( |  | ) |
| inline

Starts of integer variable going to zero.

Definition at line 138 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toOne | ( |  | ) |
| inline

Starts of integer variable going to one.

Definition at line 144 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::integerVariable | ( |  | ) | const
| inline

List of 0-1 integer variables.

Definition at line 150 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::backward | ( |  | ) | const
| inline

Backward look up.

Definition at line 155 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberVariables | ( |  | ) | const
| inline

Number of variables.

Definition at line 160 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberIntegers | ( |  | ) | const
| inline

Number of 0-1 variables.

Definition at line 165 of file CglTreeInfo.hpp.

void CglTreeProbingInfo::convert | ( |  | ) |
| private

Converts to ordered.

## Member Data Documentation

CliqueEntry* CglTreeProbingInfo::fixEntry_
| protected

Entries for fixing variables.

Definition at line 176 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toZero_
| protected

Starts of integer variable going to zero.

Definition at line 178 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::toOne_
| protected

Starts of integer variable going to one.

Definition at line 180 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::integerVariable_
| protected

List of 0-1 integer variables.

Definition at line 182 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::backward_
| protected

Backward look up.

Definition at line 184 of file CglTreeInfo.hpp.

int* CglTreeProbingInfo::fixingEntry_
| protected

Entries for fixing variable when collecting.

Definition at line 186 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberVariables_
| protected

Number of variables.

Definition at line 188 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberIntegers_
| protected

Number of 0-1 variables.

Definition at line 190 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::maximumEntries_
| protected

Maximum number in fixEntry_.

Definition at line 192 of file CglTreeInfo.hpp.

int CglTreeProbingInfo::numberEntries_
| protected

Number entries in fixingEntry_ (and fixEntry_) or -2 if correct style.

Definition at line 194 of file CglTreeInfo.hpp.

The documentation for this class was generated from the following file:

- /tmp/Cgl-0.60.2/Cgl/src/CglTreeInfo.hpp